#pragma once

#include <vector>
#include <list>
#include <map>

#define TS_SYNC_BYTE			0x47				// TSoCg
#define TS_PACKET_SIZE_188		188					// 188
#define TS_PACKET_SIZE_192		192					// 192(TTS 188+TimeStamp)
#define TS_PACKET_SIZE_204		204					// 204(188+R[h)
#define TS_PACKET_SIZE_STANDARD	TS_PACKET_SIZE_188
#define TS_PACKET_SIZE_MIN		TS_PACKET_SIZE_188
#define TS_PACKET_SIZE_MAX		TS_PACKET_SIZE_204

#define TS_PID_MAX				0x2000
#define TS_PID_NULL				0x1FFF

#define TS_MAX_PAYLOAD_LENGTH	0x1000	// 12bit

#define TS_TABLE_ID_NOTHING		0x00
#define TS_TABLE_ID_PMT			0x02
#define TS_TABLE_ID_NIT			0x40
#define TS_TABLE_ID_SIT			0x7F

//////////////////////////////////////////////////////////////////////

// TS Header 4byte
struct TS_header
{
	                                        // bit
	BYTE	sync; // 0x47 fixex!!			//  8 [0]0xFF
	BYTE	transport_error_indicator;		//  1 [1]0x80
	BYTE	payload_unit_start_indicator;	//  1 [1]0x40
	BYTE	transport_priority;				//  1 [1]0x20
	WORD	pid;							// 13 [1]0x1F [2]0xFF
	BYTE	transport_scrambling_control;	//  2 [3]0xC0
	BYTE	adaptation_field_control;		//  2 [3]0x30
	BYTE	continuity_counter;				//  4 [3]0x0F
};

// TS Secton Header 8byte
struct TS_section_header
{
										// bit
	BYTE	table_id;					//  8 [0]0xFF
	BYTE	section_syntax_indicator;	//  1 [1]0x80
	BYTE	private_indicator;			//  1 [1]0x40
										//  2 [1]0x30
	size_t	section_length;				// 12 [1]0x0F [2]0xFF
	WORD	transport_stream_id;		// 16 [3]0xFF [4]0xFF
										//  2 [5]0xC0
	BYTE	version_number;				//  5 [5]0x3E
	BYTE	current_next_indicator;		//  1 [5]0x01
	BYTE	section_number;				//  8 [6]
	BYTE	last_section_number;		//  8 [7]
};

// ȉs낿

//////////////////////////////////////////////////////////////////////
// TSC[W()
//
// TSXg[(`P)
//  L PAT    : ǂ̂悤ȃT[rX(`l)܂܂邩
//  |  L PMT : T[rXɂǂ̂悤Ȕԑg܂܂邩(}`\Ή)
//  |  L PMT : BS/CSƕ̃T[rXЂƂ̃Xg[ŗB
//  |  L PMT :
//  L NIT    : Xg[̓`AgAϒAXg[̂̂܁B
//  L SDT    : ǂ̂悤ȃT[rX邩B́AvoC_AXg[̂̂܁B
//  L EIT    : ԑgBp/fAschedule(S)̂QށBnc̏ꍇAI𒆂̕ǂ̂̂̂݁B
//           : q̏ꍇAǂ̂̂`BAɂĂp/fȂschedulê݂B


// T[rX\
struct TS_SERVICE
{
	WORD	service_number;
	WORD	pmt_pid;
};

// vO\
struct TS_PROGRAM_INFO
{
	BYTE	program_type;
	WORD	elementary_pid;
};

//////////////////////////////////////////////////////////////////////

// PAT
struct TS_PAT
{
	BYTE byVerNo;
	std::vector <struct TS_SERVICE> Programs;
};

// PMT
struct TS_PMT
{
	BYTE	byVerNo;
	WORD	pcr_pid;
	std::vector<struct TS_PROGRAM_INFO> ProgramInfo;
};
typedef std::map<WORD,struct TS_PMT> TS_StreamPmt;		// Key=T[rXID , Val=PMT
typedef std::pair<WORD,struct TS_PMT> TS_StreamPmtPair;
